/*
 * arch/arm/mach-kirkwood/include/mach/system.h
 *
 * This file is licensed under the terms of the GNU General Public
 * License version 2.  This program is licensed "as is" without any
 * warranty of any kind, whether express or implied.
 */

#ifndef __ASM_ARCH_SYSTEM_H
#define __ASM_ARCH_SYSTEM_H

#include <asm/mach-types.h>
#include <mach/bridge-regs.h>
#include <linux/gpio.h>

static inline void arch_idle(void)
{
	cpu_do_idle();
}

static inline void arch_reset(char mode, const char *cmd)
{
	if (machine_is_wtplug()) {
		if (gpio_request(9, "System Reset") != 0 ||
		    gpio_direction_output(9, 0) != 0)
			printk(KERN_ERR "can't set up GPIO 9 (System Reset)\n");		
	}
	
	/*
	 * Enable soft reset to assert RSTOUTn.
	 */
	writel(SOFT_RESET_OUT_EN, RSTOUTn_MASK);

	/*
	 * Assert soft reset.
	 */
	writel(SOFT_RESET, SYSTEM_SOFT_RESET);

	while (1)
		;
}


#endif
